package com.example.watcher;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

import android.service.notification.NotificationListenerService;
import android.service.notification.StatusBarNotification;
import android.util.Log;

public class NLService extends NotificationListenerService {

    private String TAG = this.getClass().getSimpleName();
    private NLServiceReceiver nlservicereciver;
    @Override
    public void onCreate() {
        super.onCreate();
        nlservicereciver = new NLServiceReceiver();
        IntentFilter filter = new IntentFilter();
        filter.addAction("com.example.watcher.NOTIFICATION_LISTENER_SERVICE");
        registerReceiver(nlservicereciver,filter);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unregisterReceiver(nlservicereciver);
    }

    @Override
    public void onNotificationPosted(StatusBarNotification sbn) {
        Log.d(TAG,"**********  onNotificationPosted");
        Log.d(TAG,"ID :" + sbn.getId() + "t" + sbn.getNotification().tickerText + "t" + sbn.getPackageName());
        
        Intent i = new  Intent("com.example.watcher.NOTIFICATION_LISTENER");
        i.putExtra(Constants.NOTIFICATION_KEY_CMD, Constants.NOTIFICATION_CMD_ADD);
        i.putExtra(Constants.NOTIFICATION_KEY_ID, sbn.getId());
        i.putExtra(Constants.NOTIFICATION_KEY_PACKAGE, sbn.getPackageName());
        i.putExtra(Constants.NOTIFICATION_KEY_TEXT, sbn.getNotification().tickerText);
        sendBroadcast(i);

    }

    @Override
    public void onNotificationRemoved(StatusBarNotification sbn) {
        Log.d(TAG,"********** onNOtificationRemoved");
        Log.d(TAG,"ID :" + sbn.getId() + "t" + sbn.getNotification().tickerText +"t" + sbn.getPackageName());
        
        Intent i = new  Intent("com.example.watcher.NOTIFICATION_LISTENER");
        i.putExtra(Constants.NOTIFICATION_KEY_CMD, Constants.NOTIFICATION_CMD_REMOVE);
        i.putExtra(Constants.NOTIFICATION_KEY_ID, sbn.getId());
        i.putExtra(Constants.NOTIFICATION_KEY_PACKAGE, sbn.getPackageName());
        i.putExtra(Constants.NOTIFICATION_KEY_TEXT, sbn.getNotification().tickerText);
        sendBroadcast(i);
    }

    class NLServiceReceiver extends BroadcastReceiver{

        @Override
        public void onReceive(Context context, Intent intent) {
            if(intent.getStringExtra("command").equals("clearall")){
                    NLService.this.cancelAllNotifications();
            }
            else if(intent.getStringExtra("command").equals("list")){
                for (StatusBarNotification sbn : NLService.this.getActiveNotifications()) {
                    Intent i2 = new  Intent("com.example.watcher.NOTIFICATION_LISTENER");
                    i2.putExtra(Constants.NOTIFICATION_KEY_CMD, Constants.NOTIFICATION_CMD_LIST);
                    i2.putExtra(Constants.NOTIFICATION_KEY_ID, sbn.getId());
                    i2.putExtra(Constants.NOTIFICATION_KEY_PACKAGE, sbn.getPackageName());
                    i2.putExtra(Constants.NOTIFICATION_KEY_TEXT, sbn.getNotification().tickerText);
                    sendBroadcast(i2);
                }
            }

        }
    }

}